      SUBROUTINE EC21R(A,X,BA,B,C,N,T,J1,ALFA)
         INTEGER J1,N
         REAL A,ALFA,B,BA,C,T,X
         DIMENSION A(1),B(1),BA(1),C(1),X(1)
         INTEGER I,J,K,KJ1,NI1,NJ2
         REAL A11,A12,B1,C1,FKK,H,RK,SK,U12,U1N
       H = T/(FLOAT(N)-1.)
       IF (J1 .GT. 0.5) GO TO 20
          DO 10 I = 1, N
             A(I) = H*H*A(I)
             BA(I) = H*BA(I)
   10     CONTINUE
          A11 = A(1)
          A12 = A(2)
   20  CONTINUE
       A(2) = A12 - ALFA/H
       B1 = ALFA/H/2.
       A(1) = A11 + ALFA/H*2.
       C(1) = 1./A(1)
       X(1) = BA(1)*C(1)
       B(1) = 0.
       DO 50 K = 2, N
          C(K) = 0.
          X(K) = 0.
          RK = 0.
          FKK = 0.
          DO 30 J = 2, K
             KJ1 = K - J + 1
             B(J) = C(KJ1)
             RK = RK + A(J)*B(J)
             FKK = FKK + A(J)*X(KJ1)
   30     CONTINUE
          FKK = BA(K) - FKK
          SK = 1./(1. - RK*RK)
          RK = -RK*SK
          DO 40 J = 1, K
             KJ1 = K - J + 1
             C(J) = C(J)*SK + B(J)*RK
             X(KJ1) = X(KJ1) + C(J)*FKK
   40     CONTINUE
   50  CONTINUE
       FKK = 0.
       DO 60 J = 2, N
          NJ2 = N - J + 2
          FKK = FKK - A(J)*B(NJ2)
   60  CONTINUE
       DO 70 J = 2, N
          NJ2 = N - J + 2
          C(NJ2) = (B(J) + C(NJ2)*FKK)*B1
   70  CONTINUE
       C(1) = C(1)*FKK*B1
       C1 = (1. - C(2))**2 - C(N-1)**2
       U12 = (X(2)*(1. - C(2)) + X(N-1)*C(N-1))/C1
       U1N = ((1. - C(2))*X(N-1) + X(2)*C(N-1))/C1
       DO 80 I = 1, N
          NI1 = N - I + 1
          X(I) = U12*C(I) + U1N*C(NI1) + X(I)
   80  CONTINUE
       X(1) = 2.*X(1)
       X(N) = 2.*X(N)
       RETURN
      END
